/* Proiect PM 2013
 * Jocul PONG.
 * Avram Marius: 334CB
 */
#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h>
#include <avr/pgmspace.h>
#include <stdio.h>
#include <stdlib.h>
#include "lcd.h"

#define F_CPU 			16000000
#define TRUE 			1
#define FALSE			0
#define PINITIAL_POS	16
#define BINITIAL_X		40
#define BINITIAL_Y		20
#define BOFFSET_Y		8
#define LEFT_COLUMN		1
#define RIGHT_COLUMN	80
#define TOP_LIMIT		1
#define BOTTOM_LIMIT	33
#define LEFT_PLIMIT		5
#define RIGHT_PLIMIT	76
#define SCORE_LIMIT		5

void calculate_diry(int dx, int dy, int *dirx, int *diry) {
	if (dy < -4)
		*diry = 2;
	else if (dy < -2)
		*diry = 1;
	else if (dy < 2) 
		*diry = 0;
	else if (dy < 4)
		*diry = -1;
	else if (dy < 6)
		*diry = -2;
}

int main(void)
{
	char left_platform_pos, right_platform_pos,
		 ball_x, ball_y;
	char pressed;
	int ball_dirx = 0, ball_diry = 0, dx = 0, dy = 0;
	char score_p1 = 0, score_p2 = 0;
	
	left_platform_pos = PINITIAL_POS;
	right_platform_pos = PINITIAL_POS;
	ball_x = BINITIAL_X;
	ball_y = BINITIAL_Y;

	lcd_init();
	lcd_contrast(0x50);
	
	lcd_goto_xy(6, 2);
	lcd_str("PONG");
	lcd_goto_xy(2, 3); 
	lcd_str("Marius Avram");
	lcd_goto_xy(5, 5); 
	lcd_str("334CB");
	
	DDRA = (1 << PA2);
	PORTA |= (1 << PA2);
	while (1) {
		if (!(PINA & (1 << PA2)))
		{
			lcd_clear();
			break;
		}
		_delay_ms(500);
		
	}
	
	lcd_goto_xy_pixel(ball_x, ball_y);
	lcd_chr_unspaced(BALL);
	if (rand() % 2 == 0) 
	{
		ball_dirx = 2;
	}
	else
	{
		ball_dirx = -2;
	}

	DDRA = (1 << PA0) & (1 << PA1) & 
			(1 << PA4) & (1 << PA5);
	DDRD |= (1 << PD7);
	
	while (1)
	{
		lcd_clear();
		lcd_goto_xy_pixel(LEFT_COLUMN, left_platform_pos);
		draw_platform();
		lcd_goto_xy_pixel(RIGHT_COLUMN, right_platform_pos);
		draw_platform();
		
		pressed = FALSE;
		PORTA |= (1 << PA1);
		if (!(PINA & (1 << PA1)))
		{
			PORTD |= (1 << PD7);
			if (left_platform_pos < BOTTOM_LIMIT) {
				clear_left_column();
				lcd_goto_xy_pixel(LEFT_COLUMN, ++left_platform_pos);
				draw_platform();
				pressed = TRUE;
			}
		}
		PORTA |= (1 << PA0);
		if (!(PINA & (1 << PA0)))
		{
			PORTD |= (1 << PD7);
			if (left_platform_pos > TOP_LIMIT) {
				clear_left_column();
				lcd_goto_xy_pixel(LEFT_COLUMN, --left_platform_pos);
				draw_platform();
				pressed = TRUE;
			}
		}
		PORTA |= (1 << PA4);
		if (!(PINA & (1 << PA4)))
		{
			PORTD |= (1 << PD7);
			if (right_platform_pos < BOTTOM_LIMIT) {
				clear_right_column();
				lcd_goto_xy_pixel(RIGHT_COLUMN, ++right_platform_pos);
				draw_platform();
				pressed = TRUE;
			}
		}
		PORTA |= (1 << PA5);
		if (!(PINA & (1 << PA5)))
		{
			PORTA |= (1 << PD7);
			if (right_platform_pos > TOP_LIMIT) {
				clear_right_column();
				lcd_goto_xy_pixel(RIGHT_COLUMN, --right_platform_pos);
				draw_platform();
				pressed = TRUE;
			}
		}
		
		if (!pressed)
		{
			PORTD &= ~(1 << PD7);
		}
		
		/* Redesenare minge */
		
		/* Ricosare partea stanga */
		if (ball_x == LEFT_PLIMIT+1 &&
			ball_y >= left_platform_pos-BOFFSET_Y &&
			ball_y <= left_platform_pos+12)
		{
			ball_dirx *= -1;
			dy = left_platform_pos - ball_y+3;
			dx = ball_dirx;
			calculate_diry(dx, dy, &ball_dirx, &ball_diry);
		}
		/* Ricosare partea dreapta */
		else if (ball_x == RIGHT_PLIMIT &&
			ball_y >= right_platform_pos-BOFFSET_Y && 
			ball_y <= right_platform_pos+12)
		{
			ball_dirx *= -1;
			dy = right_platform_pos - ball_y+3;
			dx = ball_dirx;
			calculate_diry(dx, dy, &ball_dirx, &ball_diry);
		}
		
		/* Lovire manta sus sau jos */
		if (ball_y < 1 || ball_y > 40) {
			ball_diry *= -1;
		}
		
		/* Progres minge */
		ball_x += ball_dirx;
		ball_y += ball_diry;
		
		lcd_goto_xy(6, 1);
		printf("%i - %i", score_p1, score_p2);
		lcd_goto_xy_pixel(ball_x, ball_y);
		lcd_chr_unspaced(BALL);
		
		_delay_ms(400);

	};
	/* Blocheaza jocul pana la reset. */
	while (1);
	return 0;
}


